<template>
  <JList>
    <JKeyboardNavItem
      v-for="user in users"
      :key="user.id"
      #default="a11yProps"
    >
      <JListItem
        v-bind="a11yProps"
        size="xl"
        class="select-user-list-item"
        @keydown.space.prevent="$emit('select', user)"
        @keydown.enter="$emit('select', user)"
        @click="$emit('select', user)"
      >
        <JOption
          :value="user.id"
          :active="isSelectedUser(user)"
        >
          <template #default="{ active }">
            <JCheckbox
              size="s"
              :active="active"
            >
              <UserChatCard :user="user" hide-status />
            </JCheckbox>
          </template>
        </JOption>
      </JListItem>
    </JKeyboardNavItem>
  </JList>
</template>

<script setup lang="ts">
import { PropType } from 'vue';
import {
  JKeyboardNavItem, JList, JListItem, JOption, JCheckbox,
} from '@new-jira-clone/ui/src/components';
import { IUser } from '@/shared';
import UserChatCard from './UserChatCard.vue';

defineEmits<{
  (event: 'select', user: IUser): void;
}>();

const props = defineProps({
  users: {
    type: Array as PropType<IUser[]>,
    required: true,
  },
  selectedUsers: {
    type: Array as PropType<IUser[]>,
    default: () => [],
  },
});

const isSelectedUser = (user: IUser): boolean => !!props.selectedUsers?.find(
  (selectedUser) => selectedUser.id === user.id,
);
</script>

<style scoped lang="scss">
.select-user-list-item {
  display: flex;
  justify-content: space-between;

  // TODO: redo deep
  :deep {
    .j-option {
      order: 2;
      margin-right: 0;
      margin-left: auto;
    }
  }
}
</style>
